using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.IO;


namespace DiskAlyse
{
    public partial class Form1 : Form
    {
        private long grandTotal = 0;
        private long driveUse;

        public Form1()
        {
            InitializeComponent();
            progressBar1.Minimum = 0;
            progressBar1.Maximum = 100;

        }

        private void button1_Click(object sender, EventArgs e)
        {
            button1.Enabled = false;
            treeView1.Nodes.Clear();

            string RootDir = drvCombo1.Text;
            DriveInfo Drive = new DriveInfo(RootDir);
            driveUse = Drive.TotalSize - Drive.AvailableFreeSpace;
            grandTotal = 0;

            TreeNode Root = new TreeNode();
            Root.Tag = new DirectoryInfo(RootDir);

            treeView1.Nodes.Add(Root);
            treeView1.BeginUpdate();
            long total = subTree(Root);
            Root.Text = total.ToString();
            treeView1.EndUpdate();
            button1.Enabled = true;
        }
        private long subTree(TreeNode currentNode)
        {

            DirectoryInfo currentDir = (DirectoryInfo)currentNode.Tag;
            textBox1.Text = currentDir.Name;
            currentNode.Text = currentDir.Name + " ";

            FileInfo[] Files = currentDir.GetFiles();
            long total = 0;
            long result = 0;
            foreach (FileInfo f in Files)
            { total += f.Length; }
            grandTotal += total;
            double progress = 1.0 -
                ((double)(driveUse - grandTotal) /
                  (double)driveUse);
            if (progress > 1) progress = 1;
            progressBar1.Value = (int)(progress * 100.0);

            DirectoryInfo[] Dirs = currentDir.GetDirectories();
            TreeNode node;

            foreach (DirectoryInfo Dir in Dirs)
            {
                node = new TreeNode();
                node.Tag = Dir;
                currentNode.Nodes.Add(node);
                currentNode.ExpandAll();
                Application.DoEvents();
                result = subTree(node);
                total += result;
            }

            currentNode.Text = currentNode.Text + total.ToString();
            if (total > 1000000000)
            {
                currentNode.ImageIndex = 1;
            }
            return total;
        }
    }
}